#/usr/bin/python

# Copyright 2011 Edmundo Carmona Antoranz
# Released under the terms of Affero GPLv3

from Music import *

class DruidSystem(JustSystem):
    """
    Tuning system as defined by John Robinson (druidmechanics ! gmail )
    
    It's a non exponential function. Like this:
    12/12 (1), 13/12, 7/6 (14/12)... 23/12.
    """
    
    DRUID_RATES = [[1, 1], # JUST FIRST
        [13, 12], # AUGMENTED FIRST
        [7, 6], # MAJOR_SECOND
        [5, 4], # AUGMENTED SECOND
        [4, 3], # MAJOR THIRD
        [17, 12], # JUST_FOURTH
        [3, 2], # AUGMENTED_FOURTH
        [19, 12], # JUST_FIFTH
        [5, 3], # AUGMENTED_FIFTH
        [7, 4], # MAJOR_SIXTH
        [11, 6], # MINOR_SEVENTH
        [23, 12]] # MAJOR_SEVENTH
    
    def __init__(self, note, alteration, baseFreq = None):
        JustSystem.__init__(self, note, alteration, baseFreq, DruidSystem.DRUID_RATES)
